
import java.net.*;
import java.io.*;
import java.util.*;

import sv.kernel.*;

/** 
 * SV.java
 * Scientific data Visualization client
 * @version 1.0
 * @author Byeongseob Ki
 */

class SV {
   DataOutputStream output = null;
   
   // connect and send the data to server 
   private void sendLoadData(String serverName, int serverPort,
                                                  Vector datafiles) {
      Socket server = null;

      try {
         for (Enumeration e=datafiles.elements(); e.hasMoreElements();) {

            if (serverName != null) 
               server = new Socket(serverName, serverPort);
            else 
               server = new Socket("localhost", serverPort);
            output = new DataOutputStream(server.getOutputStream());

            String filename = (String)e.nextElement();

            if (filename.indexOf(".sva") > 0) {
               System.out.println("Ascii data reader starts ....");
               BufferedReader bfr = new BufferedReader(new 
                                            FileReader(filename));
               SVFileReader.sendFromInput(filename, bfr, output);
            } else {
               DataInputStream input = new DataInputStream(new 
                                            FileInputStream(filename));
               SVFileReader.sendFromInput(input, output);
	    }
         }

      } catch(Exception exception) {
         exception.printStackTrace();

         try {
            server.close();
         } catch(Exception e) {
            e.printStackTrace();
            System.exit(1);
         }
         System.exit(1);
      }
  }

   public static void main(String args[]) {
      SV svClient = new SV();
      Vector incoming = new Vector();


      int i = 0;
      String host = null;
      int port = 7654;

      String arg;

      while (i < args.length) {

         if (args[i].startsWith("-")) {
            arg = args[i++];
            if (arg.equals("-h")) {
               host = args[i++];
            } else if (arg.equals("-p")) {
               port = Integer.valueOf(args[i++]).intValue();
            } 
         }  else {
            incoming.addElement(args[i++]);
         }
      }

      if (incoming.size() > 0) {
         svClient.sendLoadData(host, port, incoming);
      } else {
        System.out.println("Usage: java SV [-h hostname] [-p port] input_files...");
      }
  }

}

